Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoVRMLImageTexture Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLImageTexture.h>`

Inheritance diagram for SoVRMLImageTexture:

List of all members.

## Detailed Description

The SoVRMLImageTexture class is used for mapping a texture file onto geometry.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      ImageTexture {
        exposedField MFString url     []
        field        SFBool   repeatS TRUE
        field        SFBool   repeatT TRUE
      }

The ImageTexture node defines a texture map by specifying an image file and general parameters for mapping to geometry. Texture maps are defined in a 2D coordinate system (s, t) that ranges from [0.0, 1.0] in both directions. The bottom edge of the image corresponds to the S-axis of the texture map, and left edge of the image corresponds to the T-axis of the texture map. The lower-left pixel of the image corresponds to s=0, t=0, and the top-right pixel of the image corresponds to s=1, t=1. These relationships are depicted in Figure 6.9.

Figure 6.9

The texture is read from the URL specified by the url field. When the url field contains no values ([]), texturing is disabled. Browsers shall support the JPEG and PNG image file formats. In addition, browsers may support other image formats (e.g. CGM) which can be rendered into a 2D image. Support for the GIF format is also recommended (including transparency).

Details on the url field can be found in 4.5, VRML and the World Wide Web.

See 4.6.11, Texture maps (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.11>), for a general description of texture maps.

See 4.14, Lighting model (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.14>), for a description of lighting equations and the interaction between textures, materials, and geometry appearance.

The repeatS and repeatT fields specify how the texture wraps in the S and T directions. If repeatS is TRUE (the default), the texture map is repeated outside the [0.0, 1.0] texture coordinate range in the S direction so that it fills the shape. If repeatS is FALSE, the texture coordinates are clamped in the S direction to lie within the [0.0, 1.0] range. The repeatT field is analogous to the repeatS field.

## Public Member Functions
| SoVRMLImageTexture (void)
void | allowPrequalifyFile (SbBool enable)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | rayPick (SoRayPickAction *action)
void | setImage (const SbImage &image)
const SbImage * | getImage (void) const
## Static Public Member Functions
void | initClass (void)
void | setDelayFetchURL (const SbBool onoff)
void | setPrequalifyFileCallBack (VRMLPrequalifyFileCallback *cb, void *closure)
void | setImageDataMaxAge (const uint32_t maxage)
## Public Attributes
SoMFString | url
## Protected Member Functions
virtual | ~SoVRMLImageTexture ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
int | getReadStatus (void) const
void | setReadStatus (int status)

## Constructor & Destructor Documentation

SoVRMLImageTexture::SoVRMLImageTexture | ( | void |  | ) |

| Constructor.

SoVRMLImageTexture::~SoVRMLImageTexture | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLImageTexture::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLTexture.

void SoVRMLImageTexture::setDelayFetchURL | ( | const SbBool | onoff | ) | `[static]`

| Sets whether the image loading is delayed until the first time the image is needed, or if the image is loaded immediately when the url field is changed/set. Default value is TRUE.

void SoVRMLImageTexture::setPrequalifyFileCallBack | ( | VRMLPrequalifyFileCallback * | cb,
|  | void * | closure
| ) | `[static]`

| Sets the prequalify callback for ImageTexture nodes. This is a callback that will be called when an image is about to be read.

void SoVRMLImageTexture::allowPrequalifyFile | ( | SbBool | enable | ) |

| Enable prequalify file loading.

void SoVRMLImageTexture::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoVRMLImageTexture::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoVRMLTexture.

void SoVRMLImageTexture::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoVRMLImageTexture::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Action method for SoRayPickAction. Checks the ray specification of the action and tests for intersection with the data of the node. Nodes influencing relevant state variables for how picking is done also overrides this method. Reimplemented from SoNode.

void SoVRMLImageTexture::setImage | ( | const SbImage & | image | ) |

| Set the image data for this node. Can be used by the prequalify callback to set the data in the node.

const SbImage * SoVRMLImageTexture::getImage | ( | void |  | ) | const

| Returns the texture image.

void SoVRMLImageTexture::setImageDataMaxAge | ( | const uint32_t | maxage | ) | `[static]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SbBool SoVRMLImageTexture::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) | `[protected, virtual]`

| This method is mainly intended for internal use during file import operations. It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type. `TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`. flags is used internally during binary import when reading user extension nodes, group nodes or engines. Reimplemented from SoNode.

int SoVRMLImageTexture::getReadStatus | ( | void |  | ) | const`[protected]`

| Returns the read status.

void SoVRMLImageTexture::setReadStatus | ( | int | status | ) | `[protected]`

| Sets the read status.

The documentation for this class was generated from the following files:

- SoVRMLImageTexture.h
- ImageTexture.cpp